#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
#    Name:	Cut from Component and Paste in Place
#      By:	sdmitch
#   Usage:	Edit>Cut from Component and Paste in Place
#		Note:	
#			
#    Date:	Nov 2014
#------------------------------------------------------------------------------------------------
require 'Sketchup'
#
unless file_loaded?(__FILE__)
	UI.menu("Edit").add_item("Cut selection within Comp Instance and Paste in Place from all Instances") { SDM::Cut_and_Paste_in_Place.main }
	file_loaded(__FILE__)
end
#------------------------------------------------------------------------------------------------
module SDM

	module Cut_and_Paste_in_Place

		def self.main
			mod = Sketchup.active_model
			ent = mod.entities
			sel = mod.selection
			lay = mod.layers.map{|l| l.name}
			unless sel.empty?
				mom = sel[0].parent
				unless mom==mod
					inp = UI.inputbox(["Paste to Layer"],[mod.active_layer.name],[lay.join("|")],"Cut and Paste in Place")
					return unless inp; 
					mod.start_operation "Cut and Paste in Place"
					mod.definitions.purge_unused
					mod.active_layer='Layer0'
					@cntr = mom.name
					grp = ent.add_group sel
					cmp = grp.to_component
					@move = cmp.definition.name = "MoveMe"
					rmv = false; mod.active_layer=inp[0]
					ent.grep(Sketchup::ComponentInstance).each{|ci|
						if ci.definition.name == @cntr
							ci.definition.entities.grep(Sketchup::ComponentInstance).each{|mi|
							if mi.definition.name == @move
								org = mi.transformation.origin.transform ci.transformation
								trn = mi.transformation.to_a; trn[12]=org.x;trn[13]=org.y;trn[14]=org.z
								new = ent.add_instance(mod.definitions[@move],trn); new.explode; rmv = true
							end
							}
						end
					}
					if rmv
						mod.definitions[@cntr].entities.grep(Sketchup::ComponentInstance).each{|c|
							if c.definition.name == @move
								c.erase!
							end
						}
					end
					mod.commit_operation
				else
					UI.messagebox "Selection must be inside of a Component"
				end
			else
				UI.messagebox "Nothing Selected"
			end
		end
	end
end
